﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Xml.Linq;
using System.IO;
using ASPItalia.WebSiteGallery.Domain;
using System.Web;

namespace ASPItalia.WebSiteGallery.Data
{
  public class Gallery
  {
    string baseUrl = System.Configuration.ConfigurationSettings.AppSettings["BaseUrl"].ToString();
    string imageFolderName = System.Configuration.ConfigurationSettings.AppSettings["ImageFolder"].ToString();

    public IList<Album> GetAlbums()
    {
      IList<Album> albums = new List<Album>();

      string mainGalleryPath = String.Format("{0}/{1}", baseUrl, imageFolderName);

      DirectoryInfo dirInfo = new DirectoryInfo(HttpContext.Current.Server.MapPath(imageFolderName));
      try
      {
        DirectoryInfo[] tempAlbums = dirInfo.GetDirectories();
        foreach (var item in tempAlbums)
        {
          Album alb = new Album();
          alb.Title = item.Name;
          alb.Folder = item.Name;

          if (item.GetFiles().Count() > 0)
            alb.ImageFileName = String.Format("{0}imageservice.axd?IF={1}/{2}/{3}&H=90", baseUrl, imageFolderName, item.Name, item.GetFiles("*.jpg")[0].Name);

          albums.Add(alb);
        }
      }
      catch
      {
      }

      return albums;
    }

    public string GetXMLAlbums()
    {
      IList<Album> _albums = this.GetAlbums();

      XDocument doc = new XDocument(
          new XElement("albums",
              from alb in _albums
              select new XElement("album",
                  new XElement("Title", alb.Title),
                  new XElement("Folder", alb.Folder),
                  new XElement("ImageFileName", alb.ImageFileName)
                  )));
      return doc.ToString();
    }

    public IList<Picture> GetPicturesOfAlbum(string albumName)
    {
      IList<Picture> pictures = new List<Picture>();
      string mainGalleryPath = String.Format("{0}/{1}", imageFolderName, albumName);

      DirectoryInfo dirInfo = new DirectoryInfo(HttpContext.Current.Server.MapPath(mainGalleryPath));
      try
      {
        FileInfo[] tempPictures = dirInfo.GetFiles("*.jpg");
        foreach (var item in tempPictures)
        {
          Picture elem = new Picture();
          elem.Title = item.Name.Replace(item.Extension, "");
          elem.ImageFileName = String.Format("{0}imageservice.axd?IF={1}/{2}/{3}", baseUrl, imageFolderName, item.Directory.Name, item.Name);
          elem.AlbumTitle = albumName;

          pictures.Add(elem);
        }
      }
      catch
      {
      }
      return pictures;
    }

    public string GetXMLPicturesOfAlbum(string albumName)
    {
      IList<Picture> _pictures = this.GetPicturesOfAlbum(albumName);

      XDocument doc = new XDocument(
          new XElement("pictures",
              from pic in _pictures
              select new XElement("picture",
                  new XElement("Title", pic.Title),
                  new XElement("ImageFileName", pic.ImageFileName),
                  new XElement("AlbumTitle", pic.AlbumTitle))));

      return doc.ToString();
    }
  }
}
