﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace ASPItalia.WebSiteGallery.Helper
{
  public class ScaleStoryboard
  {
    public enum ScaleKind
    {
      ScaleIn = 0,
      ScaleOut = 1
    }

    public event CompletedEventHandler Completed;

    Storyboard _storyboard1;
    FrameworkElement _element1; //oggetto da animare
    ScaleTransform _scaleTransform1 = new ScaleTransform();
    TransformGroup _transformGroup = new TransformGroup();
    double _animationFrom = 0;
    double _animationTo = 0;

    public ScaleStoryboard(FrameworkElement elem1, ScaleKind kind) : this(elem1, kind, 0, 610) { }

    public ScaleStoryboard(FrameworkElement elem1, ScaleKind kind, double delay, double size)
    {
      if (elem1 != null)
      {
        _element1 = elem1;

        if (kind == ScaleKind.ScaleIn)
        {
          _animationFrom = 0;
          _animationTo = size;
        }
        else
        {
          _animationFrom = 1;
          _animationTo = 0;
        }

        _scaleTransform1.ScaleX = _scaleTransform1.ScaleY = (_animationTo > 0) ? 0 : 1;

        _transformGroup.Children.Add(_scaleTransform1);
        _element1.RenderTransform = _transformGroup;
        _element1.RenderTransformOrigin = new Point(0.5, 0.5);

        _element1.Opacity = _animationFrom;

        DoubleAnimation _anim1 = new DoubleAnimation();
        _anim1.To = (_animationTo > 1) ? 1 : _animationTo / 2;
        _anim1.Duration = TimeSpan.FromMilliseconds(400);
        Storyboard.SetTarget(_anim1, _element1);
        Storyboard.SetTargetProperty(_anim1, new PropertyPath("(Opacity)"));

        DoubleAnimation _anim4 = new DoubleAnimation();
        _anim4.To = _animationTo;
        _anim4.Duration = TimeSpan.FromMilliseconds(150);
        Storyboard.SetTarget(_anim4, _element1);
        Storyboard.SetTargetProperty(_anim4, new PropertyPath("(FrameworkElement.Width)"));

        DoubleAnimation _anim2 = new DoubleAnimation();
        _anim2.To = (_animationTo > 1) ? 1 : _animationTo;
        _anim2.Duration = TimeSpan.FromMilliseconds(300);
        Storyboard.SetTarget(_anim2, _element1);
        Storyboard.SetTargetProperty(_anim2, new PropertyPath("(RenderTransform).(TransformGroup.Children)[0].(ScaleTransform.ScaleX)"));

        DoubleAnimation _anim3 = new DoubleAnimation();
        _anim3.To = (_animationTo > 1) ? 1 : _animationTo;
        _anim3.Duration = TimeSpan.FromMilliseconds(300);
        Storyboard.SetTarget(_anim3, _element1);
        Storyboard.SetTargetProperty(_anim3, new PropertyPath("(RenderTransform).(TransformGroup.Children)[0].(ScaleTransform.ScaleY)"));

        _storyboard1 = new Storyboard();
        _storyboard1.Duration = TimeSpan.FromMilliseconds(400);
        _storyboard1.BeginTime = TimeSpan.FromMilliseconds(delay);
        _storyboard1.Children.Add(_anim1);
        _storyboard1.Children.Add(_anim2);
        _storyboard1.Children.Add(_anim3);
        _storyboard1.Children.Add(_anim4);
        _storyboard1.Completed += new EventHandler(_storyboard1_Completed);
      }
    }

    public void Start()
    {
      _storyboard1.Begin();
    }

    void _storyboard1_Completed(object sender, EventArgs e)
    {
      onCompleted();
    }

    public void onCompleted()
    {
      if (Completed != null)
        Completed();
    }
  }
}
