﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace ASPItalia.WebSiteGallery.Helper
{
    public class TimerStoryboard
    {
      Storyboard _storyboard1;

      public event CompletedEventHandler Completed;

      public TimerStoryboard() : this(0) { }

      public TimerStoryboard(double duration)
      {
        _storyboard1 = new Storyboard();
        _storyboard1.Duration = TimeSpan.FromMilliseconds(duration);
        _storyboard1.Completed += new EventHandler(_storyboard1_Completed);
      }

      public bool IsRunning { get; set; }

      public void Start()
      {
        _storyboard1.Begin();
      }

      public void Pause()
      {
        _storyboard1.Pause();
      }

      public void Resume()
      {
        if (_storyboard1.GetCurrentState() != ClockState.Active)
          _storyboard1.Begin();
        else
          _storyboard1.Resume();
      }

      private void onCompleted()
      {
        if (Completed != null)
          Completed();
      }

      private void _storyboard1_Completed(object sender, EventArgs e)
      {
        onCompleted();
      }
    }
}
