﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Media.Imaging;

namespace ASPItalia.WebSiteGallery.Silverlight
{
  public partial class MediaPictureControl : UserControl
  {
    public event EventHandler<DownloadProgressEventArgs> ImageDownloadProgress;
    public event EventHandler<SizeChangedEventArgs> ImageSizeChanged;
    public event EventHandler<RoutedEventArgs> ImageOpened;
    public MediaPictureControl()
    {
      InitializeComponent();

      BitmapImage img = (BitmapImage)MediaPicture.Source;
      if (img != null)
        img.DownloadProgress += new EventHandler<DownloadProgressEventArgs>(img_DownloadProgress);

      MediaPicture.ImageOpened += ((o, e) => { if (ImageOpened != null) ImageOpened(o, e); });

      MediaPicture.SizeChanged += new SizeChangedEventHandler(MediaPicture_SizeChanged);
    }

    void MediaPicture_SizeChanged(object sender, SizeChangedEventArgs e)
    {
      if (ImageSizeChanged != null)
        ImageSizeChanged(sender, e);
    }

    void img_DownloadProgress(object sender, DownloadProgressEventArgs e)
    {
      LoadingState.Text = String.Format("Loading: {0}", e.Progress * 100);
      if (ImageDownloadProgress != null)
        ImageDownloadProgress(sender, e);
    }
  }
}
